## lomiri-ui-extras 0.8.0~git20250922.edaf9ad

=== modules/CMakeLists.txt ===
add_subdirectory(Lomiri)

=== tests/unittests/Printers/CMakeLists.txt ===
include_directories(
    ${CMAKE_SOURCE_DIR}/modules/Lomiri/Components/Extras/Printers
)

set(MOCK_SOURCES
    mockbackend.h
)

add_executable(testPrintersPrinter tst_printer.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersPrinter LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_printer testPrintersPrinter)

add_executable(testPrintersPrinterJob tst_printerjob.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersPrinterJob LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_printerjob testPrintersPrinterJob)

add_executable(testPrintersPrinters tst_printers.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersPrinters LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_printers testPrintersPrinters)
set_tests_properties(tst_printers PROPERTIES
    ENVIRONMENT "XDG_DATA_DIRS=${CMAKE_CURRENT_SOURCE_DIR}/testdata")

add_executable(testPrintersPrinterModel tst_printermodel.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersPrinterModel LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_printermodel testPrintersPrinterModel)

add_executable(testPrintersPrinterFilter tst_printerfilter.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersPrinterFilter LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_printerfilter testPrintersPrinterFilter)

add_executable(testPrintersDriverModel tst_drivermodel.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersDriverModel LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_drivermodel testPrintersDriverModel)

add_executable(testPrintersJobModel tst_jobmodel.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersJobModel LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_jobmodel testPrintersJobModel)

add_executable(testPrintersJobFilter tst_jobfilter.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersJobFilter LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_jobfilter testPrintersJobFilter)

add_executable(testPrintersSignalRateLimiter tst_signalratelimiter.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersSignalRateLimiter LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_signalratelimiter testPrintersSignalRateLimiter)

add_executable(testPrintersDevice tst_printerdevice.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersDevice LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_printerdevice testPrintersDevice)

add_executable(testPrintersDeviceModel tst_printerdevicemodel.cpp ${MOCK_SOURCES})
target_link_libraries(testPrintersDeviceModel LomiriComponentsExtrasPrintersQml Qt::Test Qt::Gui)
add_test(tst_printerdevicemodel testPrintersDeviceModel)

=== modules/Lomiri/Components/Extras/Printers/CMakeLists.txt ===
project(LomiriComponentsExtrasPrintersQml)

add_definitions(-DUBUNTUCOMPONENTSEXTRASPRINTERS_LIBRARY)

include(FindCups)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CUPS_INCLUDE_DIR})

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui PrintSupport Qml Concurrent)

if(NOT CUPS_FOUND)
message(FATAL_ERROR "Could not find cups.")
endif()

qt_add_dbus_interface(
    GEN_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/org.cups.cupsd.Notifier.xml
    cupsdnotifier)

add_library(LomiriComponentsExtrasPrintersQml SHARED
    ${GEN_SOURCES}
    backend/backend.cpp
    backend/backend_cups.cpp
    backend/backend_pdf.cpp

    cups/devicesearcher.cpp
    cups/ippclient.cpp
    cups/jobloader.cpp
    cups/printerdriverloader.cpp
    cups/printerloader.cpp

    models/devicemodel.cpp
    models/drivermodel.cpp
    models/jobmodel.cpp
    models/printermodel.cpp

    printer/printer.cpp
    printer/printerjob.cpp
    printer/signalratelimiter.cpp
    printers/printers.cpp

    enums.h
    i18n.cpp
    plugin.cpp
    structs.h
    utils.h
)

target_link_libraries(LomiriComponentsExtrasPrintersQml
    Qt::DBus
    Qt::Gui
    Qt::PrintSupport
    Qt::Qml
    Qt::Concurrent
    ${CUPS_LIBRARIES}
)

find_package(QmlPlugins)

macro(add_plugin PLUGIN VERSION PATH)
    export_qmlfiles(${PLUGIN} ${PATH} DESTINATION ${QT_IMPORTS_DIR} ${ARGN})
    export_qmlplugin(${PLUGIN} ${VERSION} ${PATH} DESTINATION ${QT_IMPORTS_DIR} ${ARGN})
endmacro()

add_plugin(Lomiri.Components.Extras.Printers 0.1 Lomiri/Components/Extras/Printers TARGETS LomiriComponentsExtrasPrintersQml)

=== modules/Lomiri/Components/Extras/plugin/CMakeLists.txt ===
include(FindPkgConfig)
pkg_check_modules(EXIV2 REQUIRED exiv2)             # photoeditor

set(PLUGIN_SRC
    components.cpp
)

set(EXAMPLE_PLUGIN_SRC
    example/example-model.cpp
)

set(PHOTO_EDITOR_PLUGIN_SRC
    photoeditor/file-utils.cpp
    photoeditor/orientation.cpp
    photoeditor/photo-data.cpp
    photoeditor/photo-image-provider.cpp
    photoeditor/photo-metadata.cpp
    photoeditor/imaging.cpp
    photoeditor/photo-edit-thread.cpp
    )

set(TABS_BAR_PLUGIN_SRC
    tabsbar/drag-helper.cpp
)

include_directories(
    ${CMAKE_BINARY_DIR}
)

add_library(lomiri-ui-extras-plugin SHARED ${PLUGIN_SRC} ${PLUGIN_HDRS}
            ${EXAMPLE_PLUGIN_SRC} ${PHOTO_EDITOR_PLUGIN_SRC} ${TABS_BAR_PLUGIN_SRC})
target_link_libraries(lomiri-ui-extras-plugin
    ${EXIV2_LIBRARIES}
    Qt::Core
    Qt::Qml
    Qt::Quick
    Qt::Xml
    Qt::Widgets
)


if (ENABLE_QT6)
    find_package(Qt6 COMPONENTS ShaderToolsTools CONFIG REQUIRED)
    get_target_property(QSB_BIN Qt6::qsb LOCATION)
    if (NOT QSB_BIN)
        message(FATAL_ERROR "qsb not found")
    endif()

    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/tabsbar/tab-contour.frag.qsb
        COMMAND ${QSB_BIN} --glsl "100 es,120,150" --hlsl 50 --msl 12 -o tabsbar/tab-contour.frag.qsb ${CMAKE_CURRENT_SOURCE_DIR}/tabsbar/tab-contour.frag
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tabsbar/tab-contour.frag
        VERBATIM
    )
    qt_add_resources(lomiri-ui-extras-plugin "tabs_bar"
        PREFIX "/shaders"
        BASE ${CMAKE_CURRENT_BINARY_DIR}
        FILES ${CMAKE_CURRENT_BINARY_DIR}/tabsbar/tab-contour.frag.qsb
    )
endif()

set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml")

set(PLUGIN_DIR ${QT_IMPORTS_DIR}/Lomiri/Components/Extras)
install(TARGETS lomiri-ui-extras-plugin DESTINATION ${PLUGIN_DIR})

# copy the product of the build (plugin binary) to the test directory before
# unit tests are run, so it can be loaded by them.
# Also copy it one directory up so it can be loaded by autopilot tests when
# running them uninstalled.
add_custom_command(
            TARGET lomiri-ui-extras-plugin
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
                $<TARGET_FILE:lomiri-ui-extras-plugin>
                ${CMAKE_BINARY_DIR}/tests/unittests/Lomiri/Components/Extras/)
add_custom_command(
            TARGET lomiri-ui-extras-plugin
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
                $<TARGET_FILE:lomiri-ui-extras-plugin>
                ../)

=== modules/Lomiri/Components/Extras/qml5/Example/CMakeLists.txt ===
file(GLOB QML_FILES *.qml)
install(FILES ${QML_FILES} DESTINATION ${PLUGIN_DIR}/Example)

=== modules/Lomiri/Components/Extras/qml5/PhotoEditor/CMakeLists.txt ===
file(GLOB QML_FILES *.qml *.js)
install(FILES ${QML_FILES} DESTINATION ${PLUGIN_DIR}/PhotoEditor)
install(DIRECTORY assets DESTINATION ${PLUGIN_DIR}/PhotoEditor)

=== debian/changelog ===
lomiri-ui-extras (0.8.0~git20250922.edaf9ad-1) experimental; urgency=medium

  * New upstream release preview / Git snapshot.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 22 Sep 2025 15:17:45 +0200

=== debian/control ===
Source: lomiri-ui-extras
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               debhelper-compat (= 13),
               gettext,
               libcups2-dev,
               libexiv2-dev,
               pkgconf,
               python3:any,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-shadertools-dev,
               qml6-module-qtquick,
               qml6-module-qttest,
#               qml6-module-lomiri-components,
#               qml6-module-lomiri-test,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qml-module-qtquick2,
               qml-module-qttest,
               qml-module-lomiri-components,
               qml-module-lomiri-test,
               libpam0g-dev,
               xauth,
               xvfb,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-ui-extras
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-ui-extras/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-ui-extras.git

Package: qml-module-lomiri-components-extras
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-components-extras-common (>= ${source:Version}),
         qml-module-qtqml-models2,
         qml-module-qtquick2,
#         qml-module-lomiri-components,
         qml-module-qtquick-window2,
Description: Lomiri UI Extra Components (Qt5)
 A collection of UI components that for various reasons can't be included in
 the main Lomiri UI toolkit - mostly because of the level of quality, lack of
 documentation and/or lack of automated tests.
 .
 This package contains the Qt5 QML module.

Package: qml6-module-lomiri-components-extras
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-components-extras-common (>= ${source:Version}),
         qml6-module-qtqml-models,
         qml6-module-qtquick,
#         qml6-module-lomiri-components,
         qml6-module-qtquick-window,
Description: Lomiri UI Extra Components (Qt6)
 A collection of UI components that for various reasons can't be included in
 the main Lomiri UI toolkit - mostly because of the level of quality, lack of
 documentation and/or lack of automated tests.
 .
 This package contains the Qt6 QML module.

Package: lomiri-components-extras-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Breaks: qml-module-lomiri-components-extras (<< 0.7.0~),
Replaces: qml-module-lomiri-components-extras (<< 0.7.0~),
Description: Lomiri UI Extra Components (locale files)
 A collection of UI components that for various reasons can't be included in
 the main Lomiri UI toolkit - mostly because of the level of quality, lack of
 documentation and/or lack of automated tests.
 .
 This package contains locale files used by both (Qt5 / Qt6) QML module
 variants.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	CONFIGURE_OPTS += -DENABLE_TESTS=OFF
endif

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-qt6 --buildsystem=cmake .. -- \
	                  -DENABLE_QT6=ON                                      \
	                  $(CONFIGURE_OPTS)
	dh_auto_configure --builddirectory=build-qt5 --buildsystem=cmake .. -- \
	                  -DENABLE_QT6=OFF                                     \
	                  $(CONFIGURE_OPTS)

override_dh_auto_build:
	cp po/lomiri-ui-extras.pot po/lomiri-ui-extras.pot.bak
	dh_auto_build --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_build --builddirectory=build-qt5 --buildsystem=cmake ..

override_dh_auto_test:
	dh_auto_test --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_test --builddirectory=build-qt5 --buildsystem=cmake ..

override_dh_auto_install:
	dh_auto_install --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_install --builddirectory=build-qt5 --buildsystem=cmake ..

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_clean --builddirectory=build-qt5 --buildsystem=cmake ..

override_dh_clean:
	-mv po/lomiri-ui-extras.pot.bak po/lomiri-ui-extras.pot
	dh_clean

include /usr/share/dpkg/pkg-info.mk

PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG   = $(DEB_SOURCE)
UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
DTYPE =
VER  ?= $(subst $(DTYPE),,$(UVER))

UURL = https://gitlab.com/ubports/development/core/lomiri-ui-extras.git
UREV = $(shell echo $(VER) | cut -d"." -f4)

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz: $(info I: GIT Revision=$(UREV))
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(VER) \
	   || $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
	   && git checkout "$(UREV)" \
	   && ( echo "# Generating ChangeLog..." \
	      ; git --no-pager log --format="%ai %aN (%h) %n%n%x09*%w(68,0,10) %s%n" > ChangeLog \
	      ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
	   && echo "# Setting times..." \
	   && for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
	   && echo "# Cleaning-up..." \
	   && rm -rf debian \
	   && rm -rf .git .git*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	   | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	   && $(RM) -r "$(PKG)-$(VER)"

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=0.8.0~git%cd.%h" \
https://gitlab.com/ubports/development/core/lomiri-ui-extras.git heads/personal/gberh/luitk-qt6 debian uupdate
